#include <bits/stdc++.h>

using namespace std;
int a[1000000];
int last[10]={0,0,0,0,0,0,0,0,0,0};

int main(int argc, char** argv) {
	int n,i,k;
	bool ok;
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cin>>n;
	for(i=0;i<n;i++)
	{
		cin>>a[i];
		last[a[i]]=i;
	}
	k=0;
	ok=true;
	while(ok && k<n)
	{
		for(i=9;i>a[k];i--)
		{
			if(last[i]>k)
			{
				swap(a[last[i]],a[k]);
				ok=false;
			}
		}
		do
		{
			k++;
		}
		while(k<n && a[k]==a[k-1]);
	}
	if(ok) swap(a[n-1],a[n-2]);
	for(i=0;i<n;i++) cout<<a[i]<<" ";
	cout<<endl;
	return 0;
}